-- Prevent tainting global _.
local _
local _G = _G


local function CopyTable(SrcTable)
	local TarTable = {};
	for sKey, sValue in pairs(SrcTable) do
		if type(sValue) == "table" then
			TarTable[sKey] = {};
			TarTable[sKey] = CopyTable(sValue);
		else
			TarTable[sKey] = sValue;
		end
	end
	return TarTable;
end

function EventAlert_LoadClassSpellArray(ItemType)
	--if EA_Items[EA_playerClass] == nil then EA_Items[EA_playerClass] = {} end;
	--if EA_AltItems[EA_playerClass] == nil then EA_AltItems[EA_playerClass] = {} end;
	--if EA_Items[EA_CLASS_OTHER] == nil then EA_Items[EA_CLASS_OTHER] = {} end;
	--if EA_TarItems[EA_playerClass] == nil then EA_TarItems[EA_playerClass] = {} end;
	--if EA_ScdItems[EA_playerClass] == nil then EA_ScdItems[EA_playerClass] = {} end;
	--if EA_GrpItems[EA_playerClass] == nil then EA_GrpItems[EA_playerClass] = {} end;

	if (ItemType == 1) or (ItemType == 9 and EA_Items[EA_playerClass] == nil) then
		EA_Items[EA_playerClass] = {};
		for i, v in pairsByKeys(EADef_Items[EA_playerClass]["ITEMS"]) do
			i = tonumber(i);
			if EA_Items[EA_playerClass][i] == nil then EA_Items[EA_playerClass][i] = v end;
			if GetSpellInfo(i) == nil then EA_Items[EA_playerClass][i] = nil end;
		end
	end
	if (ItemType == 2) or (ItemType == 9 and EA_AltItems[EA_playerClass] == nil) then
		EA_AltItems[EA_playerClass] = {};
		for i, v in pairsByKeys(EADef_Items[EA_playerClass]["ALTITEMS"]) do
			i = tonumber(i);
			if EA_AltItems[EA_playerClass][i] == nil then EA_AltItems[EA_playerClass][i] = v end;
			if GetSpellInfo(i) == nil then EA_AltItems[EA_playerClass][i] = nil end;
		end
	end
	if (ItemType == 3) or (ItemType == 9 and EA_Items[EA_CLASS_OTHER] == nil) then
		EA_Items[EA_CLASS_OTHER] = {};
		for i, v in pairsByKeys(EADef_Items[EA_CLASS_OTHER]) do
			i = tonumber(i);
			if EA_Items[EA_CLASS_OTHER][i] == nil then EA_Items[EA_CLASS_OTHER][i] = v  end;
			if GetSpellInfo(i) == nil then EA_Items[EA_CLASS_OTHER][i] = nil end;
		end
	end
	if (ItemType == 4) or (ItemType == 9 and EA_TarItems[EA_playerClass] == nil) then
		EA_TarItems[EA_playerClass] = {};
		for i, v in pairsByKeys(EADef_Items[EA_playerClass]["TARITEMS"]) do
			i = tonumber(i);
			if EA_TarItems[EA_playerClass][i] == nil then EA_TarItems[EA_playerClass][i] = v end;
			if GetSpellInfo(i) == nil then EA_TarItems[EA_playerClass][i] = nil end;
		end
	end
	if (ItemType == 5) or (ItemType == 9 and EA_ScdItems[EA_playerClass] == nil) then
		EA_ScdItems[EA_playerClass] = {};
		for i, v in pairsByKeys(EADef_Items[EA_playerClass]["SCDITEMS"]) do
			i = tonumber(i);
			if EA_ScdItems[EA_playerClass][i] == nil then EA_ScdItems[EA_playerClass][i] = v end;
			if GetSpellInfo(i) == nil then EA_ScdItems[EA_playerClass][i] = nil end;
		end
	end
	if (ItemType == 6) or (ItemType == 9 and EA_GrpItems[EA_playerClass] == nil) then
		EA_GrpItems[EA_playerClass] = {};
		local iGroupCnts = 0;
		--if (#EA_GrpItems[EA_playerClass] ~= nil) then iGroupCnts = #EA_GrpItems[EA_playerClass] end;
		for i, v in pairsByKeys(EADef_Items[EA_playerClass]["GRPITEMS"]) do
			i = tonumber(i);
			if EA_GrpItems[EA_playerClass][iGroupCnts+i] == nil then EA_GrpItems[EA_playerClass][iGroupCnts+i] = {} end;
			-- EA_GrpItems[EA_playerClass][iGroupCnts+i] = v;
			EA_GrpItems[EA_playerClass][iGroupCnts+i] = CopyTable(v);
		end
	end
end


function EventAlert_LoadSpellArray()

	EADef_Items = {};

--------------------------------------------------------------------------------
-- Death Knight / `Mh
--------------------------------------------------------------------------------
	EADef_Items[EA_CLASS_DK] = {
		-- Primary Alert / ¾~
		["ITEMS"] = {
			[48707] = {enable=true,},   -- ]k@n
			[48792] = {enable=true,},   -- BD
			[49039] = {enable=true,},   -- ŧ
			[49222] = {enable=true,},   -- e
			[51124] = {enable=true,},   -- Killing  Machine / ŦD
			[52424] = {enable=true,},   -- 
			[53386] = {enable=true,},   -- Cinderglacier (Runeforge) /  Bu
			[57330] = {enable=true,},   -- V
			[59052] = {enable=true,},   -- Rime (Freezing Fog) / Bʤ
			[81141] = {enable=true,},   -- a
		},
		-- Alternate Alert / ¾~B~
		["ALTITEMS"] = {
			[56815] = {enable=true,},   -- Rune Strike / Ť奴
		},
		-- Target Alert / ؼд
		["TARITEMS"] = {
			[55095] = {enable=true, self=true,},    -- B
			[55078] = {enable=true, self=true,},    -- zE
			[81130] = {enable=true, self=true,},    -- 
			[81326] = {enable=true, self=false},	-- z
			[115798] = {enable=true, self=false,},	-- zƧ
			[117737] = {enable=true, self=false,},	-- g (]js4)
			[117756] = {enable=true, self=false,},	--  (]js4)
			[123059] = {enable=true, self=false,},	-- ʷn (5Wbuff)
			[123471] = {enable=true, self=false},	-- Wj (ߤ2)
			[126958] = {enable=true, self=false,},	-- ǩԥd٤Ĳ (]jsp)
			[127372] = {enable=true, self=false,},	-- íwM
			[131996] = {enable=true, self=false,},	-- h (׬ux4j)			
			[132726] = {enable=true, self=false,},	-- 
			[136431] = {enable=true, self=false,},	-- t߽ (p^4W)
		},
		-- Spell Cooldown Alert / ¾~ޯCD
		["SCDITEMS"] = {
			[43265] = {enable=false,},   -- `s
			[45524] = {enable=false,},   -- BN
			[47476] = {enable=false,},   -- 
			[47528] = {enable=false,},   -- ߴB
			[48707] = {enable=false,},   -- ]k@n
			[48721] = {enable=false,},   -- mN
			[48792] = {enable=false,},   -- BD
			[49020] = {enable=false,},   -- I
			[49576] = {enable=false,},   -- `
			[49998] = {enable=false,},   -- `
			[77575] = {enable=false,},   -- ̯fzo
			[85948] = {enable=false,},   -- wH
		},
		-- GroupEvent Alert / ¾~ޯ
		["GRPITEMS"] = {
			[1] = {
				enable=false,
				LocX = 0,
				LocY = -200,
				IconSize = 80,
				IconAlpha = 0.5,
				IconPoint = "Top",
				IconRelatePoint = "Top",
				-- ActiveTalentGroup=1,	-- nil for all, 1 for primary, 2 for secondary
				Spells = {
					[1] = {
						SpellIconID = 57330,	-- 57330 V
						Checks = {
							[1] = {
								CheckAndOp = true,
								SubChecks = {
									[1] = {	-- aWSBåBVbCD
										SubCheckAndOp = true,		-- s1޿BiHL
										EventType = "UNIT_AURA",	-- ƥOAݩ"AURA"
										UnitType = "player",		-- ˴HA"a"
										CheckAuraNotExist = 57330,	-- ˴"V"BuffO_"sb"
										CheckCD = 57330,		-- ˴"V"ޯO_"CD"
									},
									[2] = {	-- åB(true)AWSԤhOqq(ˬdޯधCD)
										SubCheckAndOp = true,		-- true:åB, false:Ϊ
										EventType = "UNIT_AURA",	-- ƥOAݩ"AURA"
										UnitType = "player",		-- ˴HA"a"
										CheckAuraNotExist = 6673, 	-- ˴"Oqq"BuffO_"sb"
									},
								},
							},
						},
					},
				},
			},
			[2] = {
				enable=false,
				LocX = 80,
				LocY = -200,
				IconSize = 80,
				IconAlpha = 0.5,
				IconPoint = "Top",
				IconRelatePoint = "Top",
				ActiveTalentGroup=1,	-- nil for all, 1 for primary, 2 for secondary
				Spells = {
					[1] = {
						SpellIconID = 49222,	-- 49222 b
						Checks = {
							[1] = {
								CheckAndOp = true,
								SubChecks = {
									[1] = {
										SubCheckAndOp = true,
										EventType = "UNIT_AURA",
										UnitType = "player",
										CheckAuraNotExist = 49222,
										CheckCD = 49222,
									},
								},
							},
						},
					},
				},
			},
		},
	}


--------------------------------------------------------------------------------
-- Druid / w|
--------------------------------------------------------------------------------
	EADef_Items[EA_CLASS_DRUID] = {
		-- Primary Alert / ¾~
		["ITEMS"] = {
			[16870] = {enable=true,},   -- Omen of Clarity / Mw
			[16886] = {enable=true,},   -- Nature's Grace / ۵M
			[48517] = {enable=true,},   -- Eclipse / k
			[48518] = {enable=true,},   -- Eclipse / k
			[50334] = {enable=true,},   -- Berserk / g
			[52610] = {enable=true,},   -- Savage Roar / ZHS
			[81192] = {enable=true,},   -- N
			[93400] = {enable=true,},   -- gPN
			[93622] = {enable=true,},   -- g(KOθH)
			[100977] = {enable=true,},  -- @
		},
		-- Alternate Alert / ¾~B~
		["ALTITEMS"] = {
		},
		-- Target Alert / ؼд
		["TARITEMS"] = {
			--[770] = {enable=true, self=true,},    -- Faerie Fire / F
			--[16857] = {enable=true, self=true,},  -- Faerie Fire (Feral) / F()
			--[48564] = {enable=true, self=true,},  -- Mangle(Bear) / θH(κA)
			[99] = {enable=true, self=true,},       -- өH
			[774] = {enable=true, self=true,},      -- ^KN
			[1079] = {enable=true, self=true,},     -- Rip / 
			[1822] = {enable=true, self=true,},     -- Rake / 
			[5570] = {enable=true, self=true,},     -- Insect Swarm / θs
			[8921] = {enable=true, self=true,},     -- Moonfire / N
			[33745] = {enable=true, self=true,},    -- Lacerate / ε
			[33763] = {enable=true, self=true,},    -- ͩR
			[33876] = {enable=true, self=true,},    -- Mangle(Cat) / θH(y\κA)
			[52610] = {enable=true, self=true,},    -- ZH
			[81326] = {enable=true, self=false},	-- z
			[93402] = {enable=true, self=true,},    -- Moonfire / 骢N
			[115798] = {enable=true, self=false,},	-- zƧ
			[117737] = {enable=true, self=false,},	-- g (]js4)
			[117756] = {enable=true, self=false,},	--  (]js4)
			[123059] = {enable=true, self=false,},	-- ʷn (5Wbuff)
			[123471] = {enable=true, self=false},	-- Wj (ߤ2)
			[126958] = {enable=true, self=false,},	-- ǩԥd٤Ĳ (]jsp)
			[127372] = {enable=true, self=false,},	-- íwM
			[131996] = {enable=true, self=false,},	-- h (׬ux4j)			
			[132726] = {enable=true, self=false,},	-- 
			[136431] = {enable=true, self=false,},	-- t߽ (p^4W)
		},
		-- Spell Cooldown Alert / ¾~ޯCD
		["SCDITEMS"] = {
			[17116] = {enable=false,},   -- ۵M
			[18562] = {enable=false,},   -- ¡
			[29166] = {enable=false,},   -- Ұ
			[48438] = {enable=false,},   -- ʲ¡
			[78674] = {enable=false,},   -- PN
		},
		-- GroupEvent Alert / ¾~ޯ
		["GRPITEMS"] = {
			[1] = {
				enable=false,
				LocX = 0,
				LocY = -200,
				IconSize = 80,
				IconAlpha = 0.5,
				IconPoint = "Top",
				IconRelatePoint = "Top",
				ActiveTalentGroup=1,	-- nil for all, 1 for primary, 2 for secondary
				Spells = {
					[1] = {
						SpellIconID = 5217,	-- 5217 rꤧ
						Checks = {
							[1] = {
								CheckAndOp = true,
								SubChecks = {
									[1] = {
										SubCheckAndOp = true,
										EventType = "UNIT_POWER",
										UnitType = "player",
										PowerTypeNum = 3,
										PowerType = "ENERGY",
										CheckCD = 5217,
										PowerCompType = 2,
										PowerLessThanValue = 40,
									},
								},
							},
						},
					},
				},
			},
			[2] = {
				enable=false,
				LocX = 0,
				LocY = -200,
				IconSize = 80,
				IconAlpha = 0.5,
				IconPoint = "Top",
				IconRelatePoint = "Top",
				ActiveTalentGroup=2,	-- nil for all, 1 for primary, 2 for secondary
				Spells = {
					[1] = {
						SpellIconID = 48438,	-- 48438 ¡X
						Checks = {
							[1] = {
								CheckAndOp = true,
								SubChecks = {
									[1] = {
										SubCheckAndOp = true,
										EventType = "UNIT_POWER",
										UnitType = "player",
										PowerTypeNum = 0,
										PowerType = "MANA",
										CheckCD = 48438,
										PowerCompType = 4,
										PowerLessThanValue = 5000,
									},
								},
							},
						},
					},
				},
			},
			[3] = {
				enable=false,
				LocX = 80,
				LocY = -200,
				IconSize = 80,
				IconAlpha = 0.5,
				IconPoint = "Top",
				IconRelatePoint = "Top",
				ActiveTalentGroup=2,	-- nil for all, 1 for primary, 2 for secondary
				Spells = {
					[1] = {
						SpellIconID = 29166,	-- 29166 Ұ
						Checks = {
							[1] = {
								CheckAndOp = true,
								SubChecks = {
									[1] = {
										SubCheckAndOp = true,
										EventType = "UNIT_POWER",
										UnitType = "player",
										PowerTypeNum = 0,
										PowerType = "MANA",
										CheckCD = 29166,
										PowerCompType = 2,
										PowerLessThanPercent = 80,
									},
								},
							},
						},
					},
				},
			},
			[4] = {
				enable=false,
				LocX = -80,
				LocY = -200,
				IconSize = 80,
				IconAlpha = 0.5,
				IconPoint = "Top",
				IconRelatePoint = "Top",
				ActiveTalentGroup=2,	-- nil for all, 1 for primary, 2 for secondary
				Spells = {
					[1] = {
						SpellIconID = 18562,	-- 18562 U
						Checks = {
							[1] = {
								CheckAndOp = true,
								SubChecks = {
									[1] = {
										SubCheckAndOp = true,
										EventType = "UNIT_POWER",
										UnitType = "player",
										PowerTypeNum = 0,
										PowerType = "MANA",
										CheckCD = 18562,
										PowerCompType = 4,
										PowerLessThanValue = 1700,
									},
								},
							},
						},
					},
				},
			},
			-- 1.θH 2.LεAɳε 3.εLHAɯH 4.h 5.
			[5] = {
				enable=false,
				LocX = -80,
				LocY = -200,
				IconSize = 80,
				IconAlpha = 0.5,
				IconPoint = "Top",
				IconRelatePoint = "Top",
				ActiveTalentGroup=1,	-- nil for all, 1 for primary, 2 for secondary
				Spells = {
					[1] = {
						SpellIconID = 33878,	-- θH
						Checks = {
							[1] = {
								CheckAndOp = true,	-- iL
								SubChecks = {
									[1] = {	-- a15HWAåBθHbCD
										SubCheckAndOp = true,		-- iL
										EventType = "UNIT_POWER",	-- ƥOAݩ"q"
										UnitType = "player",		-- ˴HA"a"
										PowerTypeNum = 1, 		-- qs(1:)
										PowerType = "RAGE",		-- q, iL
										CheckCD = 33878,		-- ˴"θH"ޯO_"CD"
										PowerCompType = 4,		-- q, true:p󵥩, false:j󵥩
										PowerLessThanValue = 15,	-- 15
									},
								},
							},
						},
					},
					[2] = {
						SpellIconID = 33745,	-- ε
						Checks = {
							[1] = {
								CheckAndOp = true,	-- iL
								SubChecks = {
									[1] = {	-- a15HWAåBεbCD
										SubCheckAndOp = true,		-- iL
										EventType = "UNIT_POWER",       -- ƥOAݩ"q"
										UnitType = "player",            -- ˴HA"a"
										PowerTypeNum = 1,               -- qs(1:)
										PowerType = "RAGE",             -- q, iL
										CheckCD = 33745,                -- ˴"ε"ޯO_"CD"
										PowerCompType = 4,          -- q, true:p󵥩, false:j󵥩
										PowerLessThanValue = 15,        -- 15
									},
								},
							},
							[2] = {
								CheckAndOp = true,	-- true:åB, false:Ϊ
								SubChecks = {
									[1] = {	-- ؼШWLε
										SubCheckAndOp = true,		-- iL
										EventType = "UNIT_AURA",	-- ƥOAݩ"AURA"
										UnitType = "target",		-- ˴HA"ؼ"
										CastByPlayer = true,		-- true:u˴aI
										CheckAuraNotExist = 33745,	-- ˴"ε"DeBuffO_"sb"
									},
									[2] = {	-- Ϊ(false)AؼШWεp󵥩2h|
										SubCheckAndOp = false,		-- true:åB, false:Ϊ
										EventType = "UNIT_AURA",	-- ƥOAݩ"AURA"
										UnitType = "target",		-- ˴HA"ؼ"
										CheckAuraExist = 33745,		-- ˴"ε"DeBuffO_"sb"
										CastByPlayer = true,		-- true:u˴aI
										StackCompType = 2,		-- |h, true:p󵥩, false:j󵥩
										StackLessThanValue = 2,		-- 2h
									},
									[3] = {	-- Ϊ(false)AؼШWεѾlɶAp󵥩3
										SubCheckAndOp = false,		-- true:åB, false:Ϊ
										EventType = "UNIT_AURA",	-- ƥOAݩ"AURA"
										UnitType = "target",		-- ˴HA"ؼ"
										CheckAuraExist = 33745,		-- ˴"ε"DeBuffO_"sb"
										CastByPlayer = true,		-- true:u˴aI
										TimeCompType = 2,		-- Ѿlɶ, true:p󵥩, false:j󵥩
										TimeLessThanValue = 3,		-- 3
									},
								},
							},
						},
					},
					[3] = {
						SpellIconID = 80313,	-- H
						Checks = {
							[1] = {
								CheckAndOp = true,	-- iL
								SubChecks = {
									[1] = {	-- a15HWAåBHbCD
										SubCheckAndOp = true,		-- iL
										EventType = "UNIT_POWER",       -- ƥOAݩ"q"
										UnitType = "player",            -- ˴HA"a"
										PowerTypeNum = 1,               -- qs(1:)
										PowerType = "RAGE",             -- q, iL
										CheckCD = 80313,                -- ˴"θH"ޯO_"CD"
										PowerCompType = 4,          -- q, true:p󵥩, false:j󵥩
										PowerLessThanValue = 15,        -- 15
									},
									[2] = {	-- åB(true)AؼШWaI񪺳εDebuff
										SubCheckAndOp = true,		-- true:åB, false:Ϊ
										EventType = "UNIT_AURA",	-- ƥOAݩ"AURA"
										UnitType = "target",		-- ˴HA"ؼ"
										CastByPlayer = true,		-- true:u˴aI
										CheckAuraExist = 33745,		-- ˴"ε"DeBuffO_"sb"
									},
								},
							},
							[2] = {
								CheckAndOp = true,	-- true:åB, false:Ϊ
								SubChecks = {
									[1] = {	-- aWHBuffѾlɶAp󵥩3
										SubCheckAndOp = true,		-- iL
										EventType = "UNIT_AURA",	-- ƥOAݩ"AURA"
										UnitType = "player",		-- ˴HA"a"
										CheckAuraExist = 80951,		-- ˴"H"BuffO_"sb"
										TimeCompType = 2,		-- Ѿlɶ, true:p󵥩, false:j󵥩
										TimeLessThanValue = 3,		-- 3
									},
									[2] = {	-- Ϊ(false)AaWSHBuff
										SubCheckAndOp = false,		-- true:åB, false:Ϊ
										EventType = "UNIT_AURA",	-- ƥOAݩ"AURA"
										UnitType = "player",		-- ˴HA"a"
										CheckAuraNotExist = 80951,	-- ˴"H"BuffO_"sb"
									},
								},
							},
						},
					},
					[4] = {
						SpellIconID = 77758,	-- h
						Checks = {
							[1] = {
								CheckAndOp = true,	-- iL
								SubChecks = {
									[1] = {	-- a25HWAåBhbCD
										SubCheckAndOp = true,		-- iL
										EventType = "UNIT_POWER",       -- ƥOAݩ"q"
										UnitType = "player",            -- ˴HA"a"
										PowerTypeNum = 1,               -- qs(1:)
										PowerType = "RAGE",             -- q, iL
										CheckCD = 77758,                -- ˴"h"ޯO_"CD"
										PowerCompType = 4,          -- q, true:p󵥩, false:j󵥩
										PowerLessThanValue = 25,        -- 25
									},
								},
							},
						},
					},
					[5] = {
						SpellIconID = 779,	-- 
						Checks = {
							[1] = {
								CheckAndOp = true,	-- iL
								SubChecks = {
									[1] = {	-- a25HWAåBbCD
										SubCheckAndOp = true,		-- iL
										EventType = "UNIT_POWER",       -- ƥOAݩ"q"
										UnitType = "player",            -- ˴HA"a"
										PowerTypeNum = 1,               -- qs(1:)
										PowerType = "RAGE",             -- q, iL
										CheckCD = 779,                  -- ˴""ޯO_"CD"
										PowerCompType = 4,          -- q, true:p󵥩, false:j󵥩
										PowerLessThanValue = 15,        -- 15
									},
								},
							},
						},
					},
				},
			},
		},
	}


--------------------------------------------------------------------------------
-- Hunter / yH
--------------------------------------------------------------------------------
	EADef_Items[EA_CLASS_HUNTER] = {
		-- Primary Alert / ¾~
		["ITEMS"] = {
			[3045] = {enable=true,},    -- tg
			[34471] = {enable=true,},   -- ~
			[34477] = {enable=true,},   -- ~
			[35079] = {enable=true,},   -- ~
			[53220] = {enable=true,},   -- Improved Stead Shot / jíTg
			[53257] = {enable=true,},   -- D
			[53434] = {enable=true,},   -- gI
			[56453] = {enable=true,},   -- Lock and Load / Wիݵo
			[70728] = {enable=true,},   -- zI
			[82925] = {enable=true,},   -- ǳơBNB˷ǡK
			[82926] = {enable=true,},   -- g!
			[89388] = {enable=true,},   -- ĤH
			[94007] = {enable=true,},   -- s
			[95712] = {enable=true,},   -- X˷Ǿ
		},
		-- Alternate Alert / ¾~B~
		["ALTITEMS"] = {
			[53351] = {enable=true,},   -- Kill Shot / g
		},
		-- Target Alert / ؼд
		["TARITEMS"] = {
			[1978] = {enable=true, self=true,},     -- rDv
			[1130] = {enable=true, self=true,},     -- yHLO
			[19503] = {enable=true, self=true,},    -- Xg
			[63468] = {enable=true, self=true,},    -- zg
			[117737] = {enable=true, self=false,},	-- g (]js4)
			[117756] = {enable=true, self=false,},	--  (]js4)
			[123059] = {enable=true, self=false,},	-- ʷn (5Wbuff)
			[123471] = {enable=true, self=false},	-- Wj (ߤ2)
			[126958] = {enable=true, self=false,},	-- ǩԥd٤Ĳ (]jsp)
			[127372] = {enable=true, self=false,},	-- íwM
			[131996] = {enable=true, self=false,},	-- h (׬ux4j)			
			[132726] = {enable=true, self=false,},	-- 
			[136431] = {enable=true, self=false,},	-- t߽ (p^4W)
		},
		-- Spell Cooldown Alert / ¾~ޯCD
		["SCDITEMS"] = {
			[781] = {enable=false,},     -- k
		},
		-- GroupEvent Alert / ¾~ޯ
		["GRPITEMS"] = {
		},
	}


--------------------------------------------------------------------------------
-- Mage / kv
--------------------------------------------------------------------------------
	EADef_Items[EA_CLASS_MAGE] = {
		-- Primary Alert / ¾~
		["ITEMS"] = {
			[12042] = {enable=true,},   -- kj
			[12051] = {enable=true,},   -- 
			[36032] = {enable=true,},   -- Arcane Blast / İ|
			[44544] = {enable=true,},   -- Fingers of Frost / B
			[48108] = {enable=true,},   -- Hot Streak / J
			[57761] = {enable=true,},   -- Brain Freeze / ᵲ
			[64343] = {enable=true,},   -- 
			[79683] = {enable=true,},   -- Missile Barrage! / ku!
			[87023] = {enable=true,},   -- N`
			[116257] = {enable=true,},   -- v ()
		},
		-- Alternate Alert / ¾~B~
		["ALTITEMS"] = {
		},
		-- Target Alert / ؼд
		["TARITEMS"] = {
			[12654] = {enable=true, self=true,},    -- IU
			[22959] = {enable=true, self=true,},    -- K
			[31589] = {enable=true, self=true,},    -- Slow / tN
			[44457] = {enable=true, self=true,},    -- Living Bomb / zu
			[117737] = {enable=true, self=false,},	-- g (]js4)
			[117756] = {enable=true, self=false,},	--  (]js4)
			[123059] = {enable=true, self=false,},	-- ʷn (5Wbuff)
			[123471] = {enable=true, self=false},	-- Wj (ߤ2)
			[126958] = {enable=true, self=false,},	-- ǩԥd٤Ĳ (]jsp)
			[127372] = {enable=true, self=false,},	-- íwM
			[131996] = {enable=true, self=false,},	-- h (׬ux4j)			
			[132726] = {enable=true, self=false,},	-- 
			[136431] = {enable=true, self=false,},	-- t߽ (p^4W)
		},
		-- Spell Cooldown Alert / ¾~ޯCD
		["SCDITEMS"] = {
			[122] = {enable=false,},     -- BsP
			[1953] = {enable=false,},    -- {{
			[12042] = {enable=false,},   -- kj
			[12043] = {enable=false,},   -- w
			[12051] = {enable=false,},   -- 
			[44572] = {enable=false,},   -- צB
			[45438] = {enable=false,},   -- HB̻
		},
		-- GroupEvent Alert / ¾~ޯ
		["GRPITEMS"] = {
			[1] = {
				enable=false,
				LocX = 0,
				LocY = -200,
				IconSize = 80,
				IconAlpha = 0.5,
				IconPoint = "Top",
				IconRelatePoint = "Top",
				-- ActiveTalentGroup=1,	-- nil for all, 1 for primary, 2 for secondary
				Spells = {
					[1] = {
						SpellIconID = 12051,	-- 12051 
						Checks = {
							[1] = {
								CheckAndOp = true,
								SubChecks = {
									[1] = {
										SubCheckAndOp = true,
										EventType = "UNIT_POWER",
										UnitType = "player",
										PowerTypeNum = 0,
										PowerType = "MANA",
										CheckCD = 12051,
										PowerCompType = 2,
										PowerLessThanPercent = 40,
									},
								},
							},
						},
					},
				},
			},
		},
	}


--------------------------------------------------------------------------------
-- Paladin / tMh
--------------------------------------------------------------------------------
	EADef_Items[EA_CLASS_PALADIN] = {
		-- Primary Alert / ¾~
		["ITEMS"] = {
			[498] = {enable=true,},     -- tN
			[642] = {enable=true,},     -- t޳N
			[20925] = {enable=true,},   -- Rt@
			[31821] = {enable=true,},   -- @ۥ
			[31842] = {enable=true,},   -- N
			[31850] = {enable=true,},   -- ۨê
			[31884] = {enable=true,},   -- _
			[53657] = {enable=true,},   -- ¼fP
			[59578] = {enable=true,},   -- ԪN
			[84963] = {enable=true,},   -- ݼf
			[86659] = {enable=true,},   -- jѤu@(Z)
			[86698] = {enable=true,},   -- jѤu@(DD)
			[90174] = {enable=true,},	-- tN
			[105809] = {enable=true,},   -- t_
			[114163] = {enable=true,},	-- ë
			[114637] = {enable=true,},	-- aģS
			[121467] = {enable=true,},	-- դ
			[132403] = {enable=true,},	-- ()
		},
		-- Alternate Alert / ¾~B~
		["ALTITEMS"] = {
			[24275] = {enable=true,},   -- Hammer of Wrath / 㤧
		},
		-- Target Alert / ؼд
		["TARITEMS"] = {
			[853] = {enable=true, self=true,},      -- 
			[10326] = {enable=true, self=true,},    -- hN
			[20066] = {enable=true, self=true,},    -- b
			[31803] = {enable=true, self=true,},    -- d
			[81298] = {enable=true, self=true},		-- ^m
			[81326] = {enable=true, self=false},	-- z
			[110300] = {enable=true, self=true,},	-- o
			[114163] = {enable=true, self=true,},	-- ë
			[114916] = {enable=true, self=true,},	-- DŧP
			[115798] = {enable=true, self=false,},	-- zƧ
			[117737] = {enable=true, self=false,},	-- g (]js4)
			[117756] = {enable=true, self=false,},	--  (]js4)
			[123059] = {enable=true, self=false,},	-- ʷn (5Wbuff)
			[123471] = {enable=true, self=false},	-- Wj (ߤ2)
			[126958] = {enable=true, self=false,},	-- ǩԥd٤Ĳ (]jsp)
			[127372] = {enable=true, self=false,},	-- íwM
			[131996] = {enable=true, self=false,},	-- h (׬ux4j)			
			[132726] = {enable=true, self=false,},	-- 
			[136431] = {enable=true, self=false,},	-- t߽ (p^4W)
		},
		-- Spell Cooldown Alert / ¾~ޯCD
		["SCDITEMS"] = {
			[498] = {enable=false,},     -- tN
			[853] = {enable=false,},     -- 
			[20066] = {enable=false,},   -- b
			[20925] = {enable=false,},   -- Rt@
			[28730] = {enable=false,},   -- yN
			[54428] = {enable=false,},   -- ʬD
			[96231] = {enable=false,},   -- d
			[114157] = {enable=false,},   -- DŧP
			[114158] = {enable=false,},   -- t
			[114165] = {enable=false,},   -- tW
			[115750] = {enable=false,},   -- ؤ
		},
		-- GroupEvent Alert / ¾~ޯ
		["GRPITEMS"] = {
			[1] = {
				enable=false,
				LocX = 0,
				LocY = -200,
				IconSize = 80,
				IconAlpha = 0.5,
				IconPoint = "Top",
				IconRelatePoint = "Top",
				ActiveTalentGroup=2,	-- nil for all, 1 for primary, 2 for secondary
				Spells = {
					[1] = {
						SpellIconID = 85673,	-- 85673 aģt
						Checks = {
							[1] = {
								CheckAndOp = true,
								SubChecks = {
									[1] = {
										SubCheckAndOp = true,
										EventType = "UNIT_POWER",
										UnitType = "player",
										PowerTypeNum = 9,
										PowerType = "HOLY_POWER",
										CheckCD = 85673,
										PowerCompType = 4,
										PowerLessThanValue = 3,
									},
									[2] = {
										SubCheckAndOp = true,
										EventType = "UNIT_HEALTH",
										UnitType = "target",
										HealthCompType = 2,
										HealthLessThanPercent = 80,
									},
								},
							},
						},
					},
					[2] = {
						SpellIconID = 85222,	-- 85222 ƥ(q)
						Checks = {
							[1] = {
								CheckAndOp = true,
								SubChecks = {
									[1] = {
										SubCheckAndOp = true,
										EventType = "UNIT_POWER",
										UnitType = "player",
										PowerTypeNum = 9,
										PowerType = "HOLY_POWER",
										CheckCD = 85222,
										PowerCompType = 4,
										PowerLessThanValue = 3,
									},
								},
							},
						},
					},
				},
			},
			[2] = {
				["enable"] = false,
				["LocX"] = 0,
				["LocY"] = -200,
				["IconSize"] = 80,
				["IconAlpha"] = 0.5,
				["IconPoint"] = "Top",
				["IconRelatePoint"] = "Top",
				["ActiveTalentGroup"] = 1,
				["HideOnLostTarget"] = true,
				["Spells"] = {
					[1] = {
						["SpellIconID"] = 24275,
						["Checks"] = {
							[1] = {
								["CheckAndOp"] = true,
								["SubChecks"] = {
									[1] = {
										["HealthLessThanPercent"] = 20,
										["UnitType"] = "target",
										["CheckCD"] = 24275,
										["SubCheckResult"] = false,
										["SubCheckAndOp"] = true,
										["EventType"] = "UNIT_HEALTH",
										["HealthCompType"] = 1,
									}, -- [1]
								},
							}, -- [1]
						},
					}, -- [1]
					[2] = {
						["SpellIconID"] = 879,
						["Checks"] = {
							[1] = {
								["CheckAndOp"] = true,
								["SubChecks"] = {
									[1] = {
										["SubCheckResult"] = false,
										["UnitType"] = "player",
										["SubCheckAndOp"] = true,
										["CheckCD"] = 879,
										["CheckAuraExist"] = 59578,
										["EventType"] = "UNIT_AURA",
									}, -- [1]
								},
							}, -- [1]
						},
					}, -- [2]
					[3] = {
						["SpellIconID"] = 85256,
						["Checks"] = {
							[1] = {
								["CheckAndOp"] = true,
								["SubChecks"] = {
									[1] = {
										["SubCheckAndOp"] = true,
										["PowerType"] = "HOLY_POWER",
										["UnitType"] = "player",
										["PowerLessThanValue"] = 3,
										["CheckCD"] = 85256,
										["PowerTypeNum"] = 9,
										["EventType"] = "UNIT_POWER",
										["PowerCompType"] = 4,
									}, -- [1]
									[2] = {
										["SubCheckResult"] = false,
										["UnitType"] = "player",
										["SubCheckAndOp"] = false,
										["CheckCD"] = 85256,
										["CheckAuraExist"] = 90174,
										["EventType"] = "UNIT_AURA",
									}, -- [2]
								},
							}, -- [1]
						},
					}, -- [3]
					[4] = {
						["SpellIconID"] = 20271,
						["Checks"] = {
							[1] = {
								["CheckAndOp"] = true,
								["SubChecks"] = {
									[1] = {
										["SubCheckAndOp"] = true,
										["EventType"] = "UNIT_POWER",
										["SubCheckResult"] = false,
										["PowerType"] = "MANA",
										["UnitType"] = "player",
										["PowerLessThanValue"] = 90,
										["PowerTypeNum"] = 0,
										["CheckCD"] = 20271,
										["PowerCompType"] = 4,
									}, -- [1]
								},
							}, -- [1]
						},
					}, -- [4]
					[5] = {
						["SpellIconID"] = 35395,
						["Checks"] = {
							[1] = {
								["CheckAndOp"] = true,
								["SubChecks"] = {
									[1] = {
										["SubCheckAndOp"] = true,
										["EventType"] = "UNIT_POWER",
										["SubCheckResult"] = false,
										["PowerType"] = "HOLY_POWER",
										["UnitType"] = "player",
										["PowerLessThanValue"] = 3,
										["PowerTypeNum"] = 9,
										["CheckCD"] = 35395,
										["PowerCompType"] = 1,
									}, -- [1]
									[2] = {
										["SubCheckAndOp"] = false,
										["EventType"] = "UNIT_POWER",
										["SubCheckResult"] = false,
										["PowerType"] = "MANA",
										["UnitType"] = "player",
										["PowerLessThanValue"] = 100,
										["PowerTypeNum"] = 0,
										["CheckCD"] = 35395,
										["PowerCompType"] = 4,
									}, -- [2]
								},
							}, -- [1]
						},
					}, -- [5]
				},
			}, -- [2]
		},
	}


--------------------------------------------------------------------------------
-- Priest / v
--------------------------------------------------------------------------------
	EADef_Items[EA_CLASS_PRIEST] = {
		-- Primary Alert / ¾~
		["ITEMS"] = {
			[17] = {enable=true,},      -- uN:
			[6788] = {enable=true,},    -- zF
			[47585] = {enable=true,},   -- v
			[63735] = {enable=true,},   -- t^_
			[77487] = {enable=true,},   -- tv_]
			[81206] = {enable=true,},   -- ߽B:@
			[81208] = {enable=true,},   -- ߽B:R
			[81209] = {enable=true,},   -- ߽B:d
			[81782] = {enable=true,},   -- uN:
			[87153] = {enable=true,},   -- ¤Ѩ
			[87160] = {enable=true,},   -- Fk
		},
		-- Alternate Alert / ¾~B~
		["ALTITEMS"] = {
		},
		-- Target Alert / ؼд
		["TARITEMS"] = {
			[139] = {enable=true, self=true,},      -- _
			[589] = {enable=true, self=true,},      -- Shadow Word: Pain / tN:h
			[2944] = {enable=true, self=true,},     -- Devouring Plague / FE
			[6788] = {enable=true, self=true,},     -- Weakened Soul / zF
			[34914] = {enable=true, self=true,},    -- Vampiric Touch / l大Ĳ
			[47753] = {enable=true, self=true,},    -- m
			[117737] = {enable=true, self=false,},	-- g (]js4)
			[117756] = {enable=true, self=false,},	--  (]js4)
			[123059] = {enable=true, self=false,},	-- ʷn (5Wbuff)
			[123471] = {enable=true, self=false},	-- Wj (ߤ2)
			[126958] = {enable=true, self=false,},	-- ǩԥd٤Ĳ (]jsp)
			[127372] = {enable=true, self=false,},	-- íwM
			[131996] = {enable=true, self=false,},	-- h (׬ux4j)			
			[132726] = {enable=true, self=false,},	-- 
			[136431] = {enable=true, self=false,},	-- t߽ (p^4W)
		},
		-- Spell Cooldown Alert / ¾~ޯCD
		["SCDITEMS"] = {
			[17] = {enable=false,},      -- uN:
			[10060] = {enable=false,},   -- `Jq
			[28730] = {enable=false,},   -- yN
			[32379] = {enable=false,},   -- tN:
			[33206] = {enable=false,},   -- hW
			[34433] = {enable=false,},   -- tvc]
			[47540] = {enable=false,},   -- b
			[47585] = {enable=false,},   -- v
			[81700] = {enable=false,},   -- jѨ
			[88684] = {enable=false,},   -- tN:
			[89485] = {enable=false,},   -- FM`
			[126172] = {enable=false,},   -- ߽B
		},
		-- GroupEvent Alert / ¾~ޯ
		["GRPITEMS"] = {
			[1] = {
				enable=false,
				LocX = 0,
				LocY = -200,
				IconSize = 80,
				IconAlpha = 0.5,
				IconPoint = "Top",
				IconRelatePoint = "Top",
				-- ActiveTalentGroup=1,	-- nil for all, 1 for primary, 2 for secondary
				Spells = {
					[1] = {
						SpellIconID = 34433,	-- 34433 tvc]
						Checks = {
							[1] = {
								CheckAndOp = true,
								SubChecks = {
									[1] = {
										SubCheckAndOp = true,
										EventType = "UNIT_POWER",
										UnitType = "player",
										PowerTypeNum = 0,
										PowerType = "MANA",
										CheckCD = 34433,
										PowerCompType = 2,
										PowerLessThanPercent = 70,
									},
								},
							},
						},
					},
				},
			},
			[2] = {
				enable=false,
				LocX = 80,
				LocY = -200,
				IconSize = 80,
				IconAlpha = 0.5,
				IconPoint = "Top",
				IconRelatePoint = "Top",
				ActiveTalentGroup=2,	-- nil for all, 1 for primary, 2 for secondary
				Spells = {
					[1] = {
						SpellIconID = 32379,	-- 32379 tN: 
						Checks = {
							[1] = {	-- ؼЦqp󵥩25%BåBtN:bCDC
								CheckAndOp = true,
								SubChecks = {
									[1] = {	-- ؼЦqp󵥩25%BåBtN:bCDC
										SubCheckAndOp = true,		-- iL
										EventType = "UNIT_HEALTH",	-- ƥOAݩ"q"
										UnitType = "target",		-- ˴HA"ؼ"
										CheckCD = 32379,		-- ˴"tN: "ޯO_"CD"
										HealthCompType = 2,		-- q, true:p󵥩, false:j󵥩
										HealthLessThanPercent = 25,	-- 25%
									},
								},
							},
						},
					},
				},
			},
			[3] = {
				enable=false,
				LocX = -80,
				LocY = -200,
				IconSize = 80,
				IconAlpha = 0.5,
				IconPoint = "Top",
				IconRelatePoint = "Top",
				ActiveTalentGroup=2,	-- nil for all, 1 for primary, 2 for secondary
				Spells = {
					[1] = {
						SpellIconID = 8092,	-- 8092 F_z
						Checks = {
							[1] = {
								CheckAndOp = true,
								SubChecks = {
									[1] = {	-- zCDABMP
										SubCheckAndOp = true,
										EventType = "UNIT_POWER",
										UnitType = "player",
										PowerTypeNum = 0,
										PowerType = "MANA",
										CheckCD = 8092,
										PowerCompType = 4,
										PowerLessThanValue = 3500,
									},
									[2] = {	-- B ²ysb
										SubCheckAndOp = true,
										EventType = "UNIT_AURA",
										UnitType = "player",
										CheckAuraExist = 77487,
									},
								},
							},
							[2] = {
								CheckAndOp = true,
								SubChecks = {
									[1] = {	-- y3
										SubCheckAndOp = true,
										EventType = "UNIT_AURA",
										UnitType = "player",
										CheckAuraExist = 95799,
										TimeCompType = 2,
										TimeLessThanValue = 3,
									},
									[2] = {	--  ysb
										SubCheckAndOp = false,
										EventType = "UNIT_AURA",
										UnitType = "player",
										CheckAuraNotExist = 95799,
									},
									[3] = {	--  ²yx3
										SubCheckAndOp = false,
										EventType = "UNIT_AURA",
										UnitType = "player",
										CheckAuraExist = 77487,
										StackCompType = 4,
										StackLessThanValue = 3,
									},
								},
							},
						},
					},
					[2] = {
						SpellIconID = 34914,	-- 34914 l大Ĳ
						Checks = {
							[1] = {
								CheckAndOp = true,
								SubChecks = {
									[1] = {	-- l大ĲCDABMP
										SubCheckAndOp = true,
										EventType = "UNIT_POWER",
										UnitType = "player",
										PowerTypeNum = 0,
										PowerType = "MANA",
										CheckCD = 34914,
										PowerCompType = 4,
										PowerLessThanValue = 3300,
									},
								},
							},
							[1] = {
								CheckAndOp = true,
								SubChecks = {
									[1] = {	-- l大Ĳ2
										SubCheckAndOp = true,
										EventType = "UNIT_AURA",
										UnitType = "target",
										CastByPlayer = true,
										CheckAuraExist = 34914,
										TimeCompType = 2,
										TimeLessThanValue = 2,
									},
									[2] = {	--  ؼШW L l大Ĳ
										SubCheckAndOp = false,
										EventType = "UNIT_AURA",
										UnitType = "target",
										CastByPlayer = true,
										CheckAuraNotExist = 34914,
									},
								},
							},
						},
					},
					[3] = {
						SpellIconID = 589,	-- 589 tN:h
						Checks = {
							[1] = {
								CheckAndOp = true,
								SubChecks = {
									[1] = {
										SubCheckAndOp = true,
										EventType = "UNIT_POWER",
										UnitType = "player",
										PowerTypeNum = 0,
										PowerType = "MANA",
										CheckCD = 589,
										PowerCompType = 4,
										PowerLessThanValue = 4100,
									},
									[2] = {
										SubCheckAndOp = true,
										EventType = "UNIT_AURA",
										UnitType = "target",
										CastByPlayer = true,
										CheckAuraNotExist = 589,
									},
								},
							},
						},
					},
					[4] = {
						SpellIconID = 2944,	-- 2944 FE
						Checks = {
							[1] = {
								CheckAndOp = true,
								SubChecks = {
									[1] = {
										SubCheckAndOp = true,
										EventType = "UNIT_POWER",
										UnitType = "player",
										PowerTypeNum = 0,
										PowerType = "MANA",
										CheckCD = 2944,
										PowerCompType = 4,
										PowerLessThanValue = 4800,
									},
									[2] = {
										SubCheckAndOp = true,
										EventType = "UNIT_AURA",
										UnitType = "target",
										CastByPlayer = true,
										CheckAuraNotExist = 2944,
									},
								},
							},
						},
					},
				},
			},
		},
	}


--------------------------------------------------------------------------------
-- Rogue / s
--------------------------------------------------------------------------------
	EADef_Items[EA_CLASS_ROGUE] = {
		-- Primary Alert / ¾~
		["ITEMS"] = {
			[5171] = {enable=true,},    -- 
			[1966] = {enable=true,},    -- ˧
			[57934] = {enable=true,},   -- Ѵ
			[59628] = {enable=true,},   -- Ѵ
			[58427] = {enable=true,},   -- 
			[84590] = {enable=true,},   -- PR}
		},
		-- Alternate Alert / ¾~B~
		["ALTITEMS"] = {
			[14251] = {enable=true,},   -- Riposte / 
		},
		-- Target Alert / ؼд
		["TARITEMS"] = {
			[1943] = {enable=true, self=true,},     -- ε
			[84617] = {enable=true, self=true,},    -- 
			[117737] = {enable=true, self=false,},	-- g (]js4)
			[117756] = {enable=true, self=false,},	--  (]js4)
			[123059] = {enable=true, self=false,},	-- ʷn (5Wbuff)
			[123471] = {enable=true, self=false},	-- Wj (ߤ2)
			[126958] = {enable=true, self=false,},	-- ǩԥd٤Ĳ (]jsp)
			[127372] = {enable=true, self=false,},	-- íwM
			[131996] = {enable=true, self=false,},	-- h (׬ux4j)			
			[132726] = {enable=true, self=false,},	-- 
			[136431] = {enable=true, self=false,},	-- t߽ (p^4W)
		},
		-- Spell Cooldown Alert / ¾~ޯCD
		["SCDITEMS"] = {
			[65961] = {enable=false,},   -- tvܭ
			[79140] = {enable=false,},   -- J
		},
		-- GroupEvent Alert / ¾~ޯ
		["GRPITEMS"] = {
			[1] = {
				enable=false,
				LocX = 0,
				LocY = -200,
				IconSize = 80,
				IconAlpha = 0.5,
				IconPoint = "Top",
				IconRelatePoint = "Top",
				--ActiveTalentGroup=2,	-- nil for all, 1 for primary, 2 for secondary
				Spells = {
					[1] = {
						SpellIconID = 53,	-- 53 I
						Checks = {
							[1] = {
								CheckAndOp = true,
								SubChecks = {
									[1] = {
										SubCheckAndOp = true,
										EventType = "UNIT_POWER",
										UnitType = "player",
										PowerTypeNum = 3,
										PowerType = "ENERGY",
										CheckCD = 53,
										PowerCompType = 4,
										PowerLessThanValue = 40,
									},
									[2] = {
										SubCheckAndOp = true,
										EventType = "UNIT_HEALTH",
										UnitType = "target",
										HealthCompType = 2,
										HealthLessThanPercent = 35,
									},
								},
							},
						},
					},
				},
			},
		},
	}


--------------------------------------------------------------------------------
-- Shaman / ĺ
--------------------------------------------------------------------------------
	EADef_Items[EA_CLASS_SHAMAN] = {
		-- Primary Alert / ¾~
		["ITEMS"] = {
			[324] = {enable=true,},		-- {q
			[16166] = {enable=true,},	-- q
			[16188] = {enable=true,},	-- 
			[30884] = {enable=true,},	-- ۵Mu@
			[53390] = {enable=true,},	-- v
			[53817] = {enable=true, stack=5,},	-- xZ
			[73685] = {enable=true,},	-- jaͩR
			[79206] = {enable=true,},	-- F̤
			[105763] = {enable=true,},	-- FEy (kO)
			[114050] = {enable=true,},	-- VN]^
			[114051] = {enable=true,},	-- VN]Wj^
			[114052] = {enable=true,},	-- VN]_^
			[114893] = {enable=true,},	-- ۤS
			[118522] = {enable=true,},	-- 
		},
		-- Alternate Alert / ¾~B~
		["ALTITEMS"] = {
		},
		-- Target Alert / ؼд
		["TARITEMS"] = {
			[8050] = {enable=true, self=true,},		-- PK_
			[51514] = {enable=true, self=true,},	-- N
			[100955] = {enable=true, self=true,},	-- p^
			[117737] = {enable=true, self=false,},	-- g (]js4)
			[117756] = {enable=true, self=false,},	--  (]js4)
			[123059] = {enable=true, self=false,},	-- ʷn (5Wbuff)
			[123471] = {enable=true, self=false},	-- Wj (ߤ2)
			[126958] = {enable=true, self=false,},	-- ǩԥd٤Ĳ (]jsp)
			[127372] = {enable=true, self=false,},	-- íwM
			[131996] = {enable=true, self=false,},	-- h (׬ux4j)			
			[132726] = {enable=true, self=false,},	-- 
			[136431] = {enable=true, self=false,},	-- t߽ (p^4W)
		},
		-- Spell Cooldown Alert / ¾~ޯCD
		["SCDITEMS"] = {
			[16166] = {enable=false,},	-- q
			[16188] = {enable=false,},	-- 
			[16190] = {enable=false,},	-- kO
			[51505] = {enable=false,},	-- zo
			[61295] = {enable=false,},	-- Ey
			[73680] = {enable=false,},	-- 񤸯q
			[73920] = {enable=false,},	-- v¡B
			[79206] = {enable=false,},	-- F̤
			[98008] = {enable=false,},	-- Fs
			[108270] = {enable=false,},	-- ۤS
			[108271] = {enable=false,},	-- Pಾ
			[108280] = {enable=false,},	-- ¡
			[108285] = {enable=false,},	-- I

		},
		-- GroupEvent Alert / ¾~ޯ
		["GRPITEMS"] = {
			[1] = {
				["enable"] = false,
				["LocX"] = 0,
				["LocY"] = -200,
				["IconSize"] = 80,
				["IconAlpha"] = 0.5,
				["IconPoint"] = "Top",
				["IconRelatePoint"] = "Top",
				["ActiveTalentGroup"] = 2,
				["HideOnLeaveCombat"] = true,
				["Spells"] = {
					[1] = {
						["SpellIconID"] = 51505,
						["Checks"] = {
							[1] = {
								["CheckAndOp"] = true,
								["SubChecks"] = {
									[1] = {
										["SubCheckAndOp"] = true,
										["EventType"] = "UNIT_POWER",
										["UnitType"] = "player",
										["PowerTypeNum"] = 0,
										["PowerType"] = "MANA",
										["CheckCD"] = 51505,
										["PowerCompType"] = 4,
										["PowerLessThanValue"] = 380,
									}, -- [1]
								},
							}, -- [1]
						},
					}, -- [1]
					[2] = {
						["SpellIconID"] = 8050,
						["Checks"] = {
							[1] = {
								["CheckAndOp"] = true,
								["SubChecks"] = {
									[1] = {
										["SubCheckAndOp"] = true,
										["EventType"] = "UNIT_AURA",
										["UnitType"] = "target",
										["CheckCD"] = 8050,
										["CheckAuraNotExist"] = 8050,
										["CastByPlayer"] = true,
									}, -- [1]
									[2] = {
										["SubCheckAndOp"] = false,
										["EventType"] = "UNIT_AURA",
										["UnitType"] = "target",
										["CastByPlayer"] = true,
										["CheckAuraExist"] = 8050,
										["CheckCD"] = 8050,
										["TimeCompType"] = 2,
										["TimeLessThanValue"] = 5,
									}, -- [2]
								},
							}, -- [1]
						},
					}, -- [2]
					[3] = {
						["SpellIconID"] = 8042,
						["Checks"] = {
							[1] = {
								["CheckAndOp"] = true,
								["SubChecks"] = {
									[1] = {
										["SubCheckAndOp"] = true,
										["EventType"] = "UNIT_AURA",
										["UnitType"] = "target",
										["CheckCD"] = 8042,
										["CastByPlayer"] = true,
										["CheckAuraExist"] = 8050,
										["TimeCompType"] = 5,
										["TimeLessThanValue"] = 5,
									}, -- [1]
									[2] = {
										["SubCheckAndOp"] = true,
										["EventType"] = "UNIT_AURA",
										["UnitType"] = "player",
										["CheckAuraExist"] = 324,
										["StackCompType"] = 4,
										["StackLessThanValue"] = 9,
									}, -- [2]
								},
							}, -- [1]
							[2] = {
								["CheckAndOp"] = false,
								["SubChecks"] = {
									[1] = {
										["SubCheckAndOp"] = true,
										["EventType"] = "UNIT_AURA",
										["UnitType"] = "target",
										["CheckCD"] = 8042,
										["CastByPlayer"] = true,
										["CheckAuraExist"] = 8050,
										["TimeCompType"] = 3,
										["TimeLessThanValue"] = 5,
									}, -- [1]
									[2] = {
										["SubCheckAndOp"] = true,
										["EventType"] = "UNIT_AURA",
										["UnitType"] = "player",
										["CheckAuraExist"] = 324,
										["StackCompType"] = 4,
										["StackLessThanValue"] = 7,
									}, -- [2]
								},
							}, -- [2]
						},
					}, -- [3]
				},
			}, -- [1]
			[2] = {
				["enable"] = false,
				["LocX"] = 0,
				["LocY"] = -200,
				["IconSize"] = 80,
				["IconAlpha"] = 0.5,
				["IconPoint"] = "Top",
				["IconRelatePoint"] = "Top",
				["ActiveTalentGroup"] = 2,
				["Spells"] = {
					[1] = {
						["SpellIconID"] = 324,
						["Checks"] = {
							[1] = {
								["CheckAndOp"] = true,
								["SubChecks"] = {
									[1] = {
										["SubCheckAndOp"] = true,
										["EventType"] = "UNIT_AURA",
										["UnitType"] = "player",
										["CheckCD"] = 324,
										["CheckAuraExist"] = 324,
										["CastByPlayer"] = true,
										["TimeCompType"] = 1,
										["TimeLessThanValue"] = 60,
									}, -- [1]
									[2] = {
										["SubCheckAndOp"] = false,
										["EventType"] = "UNIT_AURA",
										["UnitType"] = "player",
										["CheckAuraNotExist"] = 324,
									}, -- [2]
								},
							}, -- [1]
						},
					}, -- [1]
				},
			}, -- [2]
		},
	}


--------------------------------------------------------------------------------
-- Warlock / Nh
--------------------------------------------------------------------------------
	EADef_Items[EA_CLASS_WARLOCK] = {
		-- Primary Alert / ¾~
		["ITEMS"] = {
			[18095] = {enable=true,},   -- ]
			[19028] = {enable=true,},   -- F쵲
			[34939] = {enable=true,},   -- Ͻ
			[47283] = {enable=true,},   -- Empowered Imp / jOp
			[63158] = {enable=true,},   -- Oh
			[63167] = {enable=true,},   -- Oh
			[71165] = {enable=true,},   -- 
			[85383] = {enable=true,},   -- jF
			[89937] = {enable=true,},   -- ]Ƥ
		},
		-- Alternate Alert / ¾~B~
		["ALTITEMS"] = {
		},
		-- Target Alert / ؼд
		["TARITEMS"] = {
			[172] = {enable=true, self=true,},      -- Corruption / GkN
			[348] = {enable=true, self=true,},      -- Immolate / m
			[686] = {enable=true, self=true,},      -- a
			[603] = {enable=true, self=true,},      -- tvb
			[980] = {enable=true, self=true,},      -- hWa
			[1490] = {enable=true, self=true,},     -- Curse of the Elements / AG
			[29722] = {enable=true, self=true,},    -- N
			[30108] = {enable=true, self=true,},    -- hW
			[48181] = {enable=true, self=true,},    -- kN
			[50796] = {enable=true, self=true,},    -- VPb
			[80240] = {enable=true, self=true,},    -- ETa
			[86000] = {enable=true, self=true,},    -- jAG
			[117737] = {enable=true, self=false,},	-- g (]js4)
			[117756] = {enable=true, self=false,},	--  (]js4)
			[123059] = {enable=true, self=false,},	-- ʷn (5Wbuff)
			[123471] = {enable=true, self=false},	-- Wj (ߤ2)
			[126958] = {enable=true, self=false,},	-- ǩԥd٤Ĳ (]jsp)
			[127372] = {enable=true, self=false,},	-- íwM
			[131996] = {enable=true, self=false,},	-- h (׬ux4j)			
			[132726] = {enable=true, self=false,},	-- 
			[136431] = {enable=true, self=false,},	-- t߽ (p^4W)
		},
		-- Spell Cooldown Alert / ¾~ޯCD
		["SCDITEMS"] = {
			[17962] = {enable=false,},   -- IN
			[59672] = {enable=false,},   -- c]ƨ
			[71165] = {enable=false,},   -- 
		},
		-- GroupEvent Alert / ¾~ޯ
		["GRPITEMS"] = {
		},
	}


--------------------------------------------------------------------------------
-- Warrior / Ԥh
--------------------------------------------------------------------------------
	EADef_Items[EA_CLASS_WARRIOR] = {
		-- Primary Alert / ¾~
		["ITEMS"] = {
			[871] = {enable=true,},     -- (mA)
			[1134] = {enable=true,},    -- F
			[2565] = {enable=true,},    -- ޵P(mA)
			[12328] = {enable=true,},   -- (԰AgɫA)
			[12964] = {enable=true,},   -- ԰H
			[12975] = {enable=true,},   -- }H
			[14202] = {enable=true,},   -- g( 3)
			[16491] = {enable=true,},   -- 大g
			[20230] = {enable=true,},   -- (԰A)
			[23885] = {enable=true,},   -- ݦ
			[23920] = {enable=true,},   -- kNϮg(԰AmA)
			[29841] = {enable=true,},   -- _d(1)
			[32216] = {enable=true,},   -- ӧQ
			[46916] = {enable=true,},   -- Bloodsurge (Slam) / m
			[50227] = {enable=true,},   -- CަX
			[52437] = {enable=true,},   -- J`
			[55694] = {enable=true,},   -- g_
			[57516] = {enable=true,},   -- g( 2)
			[57519] = {enable=true,},   -- g( 2)
			[60503] = {enable=true,},   -- {
			[65156] = {enable=true,},   -- դi
			[82368] = {enable=true,},   -- ӧQ
			[84586] = {enable=true,},   -- O_( 3)
			[84620] = {enable=true,},   -- u}u
			[85730] = {enable=true,},   -- I۱
			[86627] = {enable=true,},   -- E
			[87096] = {enable=true,},   -- p
			[90806] = {enable=true,},   -- BM
		},
		-- Alternate Alert / ¾~B~
		["ALTITEMS"] = {
		},
		-- Target Alert / ؼд
		["TARITEMS"] = {
			[81326] = {enable=true, self=false},	-- z
			[94009] = {enable=true, self=true,},    -- 
			[115798] = {enable=true, self=false,},	-- zƧ
			[117737] = {enable=true, self=false,},	-- g (]js4)
			[117756] = {enable=true, self=false,},	--  (]js4)
			[123059] = {enable=true, self=false,},	-- ʷn (5Wbuff)
			[123471] = {enable=true, self=false},	-- Wj (ߤ2)
			[126958] = {enable=true, self=false,},	-- ǩԥd٤Ĳ (]jsp)
			[127372] = {enable=true, self=false,},	-- íwM
			[131996] = {enable=true, self=false,},	-- h (׬ux4j)			
			[132726] = {enable=true, self=false,},	-- 
			[136431] = {enable=true, self=false,},	-- t߽ (p^4W)
		},
		-- Spell Cooldown Alert / ¾~ޯCD
		["SCDITEMS"] = {
		},
		-- GroupEvent Alert / ¾~ޯ
		["GRPITEMS"] = {
		},
	}


--------------------------------------------------------------------------------
-- Monk / Z
--------------------------------------------------------------------------------
	EADef_Items[EA_CLASS_MONK] = {
		-- Primary Alert / ¾~
		["ITEMS"] = {
			[115175] = {enable=true,},   -- ΩM
			[118674] = {enable=true,},   -- 묡g
			[119611] = {enable=true,},   -- ^Ͱg
			[120954] = {enable=true,},   -- ۧεC
			[125359] = {enable=true,},   -- 
			[132120] = {enable=true,},   -- g·¶
		},
		-- Alternate Alert / ¾~B~
		["ALTITEMS"] = {
		},
		-- Target Alert / ؼд
		["TARITEMS"] = {
			[81326] = {enable=true, self=false},	-- z
			[115078] = {enable=true, self=true,},   -- I
			[115175] = {enable=true, self=true,},   -- ΩM
			[115798] = {enable=true, self=false,},	-- zƧ
			[119611] = {enable=true, self=true,},   -- ^Ͱg
			[132120] = {enable=true, self=true,},   -- g·¶
			[115798] = {enable=true, self=false,},	-- zƧ
			[117737] = {enable=true, self=false,},	-- g (]js4)
			[117756] = {enable=true, self=false,},	--  (]js4)
			[123059] = {enable=true, self=false,},	-- ʷn (5Wbuff)
			[123471] = {enable=true, self=false},	-- Wj (ߤ2)
			[126958] = {enable=true, self=false,},	-- ǩԥd٤Ĳ (]jsp)
			[127372] = {enable=true, self=false,},	-- íwM
			[131996] = {enable=true, self=false,},	-- h (׬ux4j)			
			[132726] = {enable=true, self=false,},	-- 
			[136431] = {enable=true, self=false,},	-- t߽ (p^4W)
		},
		-- Spell Cooldown Alert / ¾~ޯCD
		["SCDITEMS"] = {
			[101545] = {enable=false,},   -- s}
			[109132] = {enable=false,},   -- ½
			[113656] = {enable=false,},   -- gs
			[115008] = {enable=false,},   -- us
			[115078] = {enable=false,},   -- I
			[115080] = {enable=false,},   -- խߴx
			[115098] = {enable=false,},   -- ui
			[115151] = {enable=false,},   -- ^Ͱg
			[115203] = {enable=false,},   -- ۧεC
			[115288] = {enable=false,},   -- C
			[115399] = {enable=false,},   -- uC
			[116705] = {enable=false,},   -- ѥ
			[116847] = {enable=false,},   -- ɯe
			[119381] = {enable=false,},   -- L
			[119392] = {enable=false,},   -- KľWi
			[122278] = {enable=false,},   -- lZ
			[122470] = {enable=false,},   -- [
			[122783] = {enable=false,},   -- ]Z
			[123904] = {enable=false,},   -- lժ곷
		},
		-- GroupEvent Alert / ¾~ޯ
		["GRPITEMS"] = {
		},
	}


--------------------------------------------------------------------------------
-- Other / ¾~@q
--------------------------------------------------------------------------------
	EADef_Items[EA_CLASS_OTHER] = {
		[17] = {enable=true,},		-- v - uN:
		[7001] = {enable=true,},	-- v - u_
		[10060] = {enable=true,},	-- v - `Jq
		[16191] = {enable=true,},	-- ĺ - kO
		[29166] = {enable=true,},	-- w| - Ұ
		[33206] = {enable=true,},	-- v - hW
		[81782] = {enable=true,},	-- v - uN:
		[98007] = {enable=true,},	-- ĺ - Fs

		[32182] = {enable=true,},	-- ĺ - ^i
		[80353] = {enable=true,},	-- kv - ɶᦱ
		[90355] = {enable=true,},	-- yH - Wjg

		[104993] = {enable=true,},	-- ɻ (])
		[116631] = {enable=true,},	--  (])
		[120032] = {enable=true,},	-- KR (])
		[125487] = {enable=true,},	--  (])
		[125488] = {enable=true,},	-- t (])
		[126266] = {enable=true,},	-- һX (ŪG)
		[126577] = {enable=true,},	-- F (tz)
		[126582] = {enable=true,},	-- O (p̫RO)
		[126599] = {enable=true,},	-- et (Aɨr蹳)
		[126640] = {enable=true,},	-- P (Ӷ)
		[126646] = {enable=true,},	-- ĲI (L)
		[126657] = {enable=true,},	-- B (t۴)
		[128984] = {enable=true,},	-- ѯ (t)
		[128985] = {enable=true,},	-- ѯ (Nt)
		[128986] = {enable=true,},	-- ѯ (t)
		[128987] = {enable=true,},	-- ѯ (st)
		[128988] = {enable=true,},	-- ѯ@ (t)
		[136087] = {enable=true,},	-- xߪ (v蠟ŧwG)
		[138728] = {enable=true,},	-- Բi (v蠟ŧwG)
	
		[117878] = {enable=true,overgrow=6},	-- W (]js_w5-Ա^)
		[118091] = {enable=true,overgrow=5},	-- pa (׬ux1)
		[118977] = {enable=true,redsectext=5},	-- L (׬ux4)
		[122752] = {enable=true,},	-- tv (׬ux2)
		[122768] = {enable=true,overgrow=8},	-- Ƴv (׬ux2)
		[122858] = {enable=true,},	-- Ţn (׬ux2)
		[123081] = {enable=true,},	-- ӷP (ߤ3)
		[123121] = {enable=true,overgrow=8},	-- Qq (׬ux3)
		[123180] = {enable=true,},	-- eB (ߤ2)
		[123474] = {enable=true,overgrow=2},	-- ˩ŧ (ߤ2)
		[123707] = {enable=true,overgrow=3},	-- kӤ (ߤ6)
		[130742] = {enable=true,redsectext=5},	-- L (׬ux4)
		
		[136767] = {enable=true,overgrow=5},	-- T (p^2)
		[136903] = {enable=true,overgrow=9},	-- YH (p^3-)
		[136911] = {enable=true,overgrow=9},	-- YH (p^3-)
		[138002] = {enable=true,},	-- yĪG (p^1W)
		[138349] = {enable=true,},	-- Rqж (p^1)
		[138389] = {enable=true,},	-- Rqж (p^1)
		
	}


end